Difference between revisions of "Draft Mirror/tr"

From FreeCAD Documentation
Jump to navigation Jump to search
(Updating to match new version of source page)
(Updating to match new version of source page)
 
(16 intermediate revisions by 2 users not shown)
Line 1: Line 1:
 
<languages/>
 
<languages/>
{{Docnav|[[Draft_Drawing|Drawing]]|[[Draft_Stretch|Stretch]]|[[Draft_Module|Draft]]|IconL=Draft_Drawing.svg|IconC=Workbench_Draft.svg|IconR=Draft_Stretch.svg}}
+
 
 +
{{Docnav
 +
|[[Draft_Scale|Scale]]
 +
|[[Draft_Offset|Offset]]
 +
|[[Draft_Workbench|Draft]]
 +
|IconL=Draft_Scale.svg
 +
|IconR=Draft_Offset.svg
 +
|IconC=Workbench_Draft.svg
 +
}}
  
 
<div class="mw-translate-fuzzy">
 
<div class="mw-translate-fuzzy">
{{GuiCommand/tr|Name=Draft Mirror|Name/tr=Yansıt|Workbenches=[[Draft Module/tr|Draft]], [[Arch Module/tr|Arch]]|MenuLocation=Draft → Mirror|SeeAlso=[[Draft Scale/tr|Draft Scale]]}}
+
{{GuiCommand/tr
 +
|Name=Draft Mirror
 +
|Name/tr=Yansıt
 +
|MenuLocation=Draft → Mirror
 +
|Workbenches=[[Draft_Workbench/tr|Draft]], [[Arch_Workbench/tr|Arch]]
 +
|Shortcut={{KEY|M}} {{KEY|I}}
 +
|SeeAlso=[[Draft Scale/tr|Draft Scale]]
 +
}}
 
</div>
 
</div>
  
==Description==
+
==Description==  
The Mirror tool produces a mirrored copy of a selected object, using the [[Part Mirror]] operation. The copy, just like a [[Draft Clone]], is linked to the original object. This means that if the original object changes its shape and properties, the mirrored shape changes as well.
 
  
The Mirror tool can be used on 2D shapes created with the [[Draft Workbench]], but can also be used on many types of 3D objects such as those created with the [[Part Workbench|Part]], [[PartDesign Workbench|PartDesign]], or [[Arch Workbench]]es.
+
The [[Image:Draft_Mirror.svg|24px]] '''Draft Mirror''' command creates mirrored copies, [[Part_Mirror|Part Mirror]] objects, from selected objects. A [[Part_Mirror|Part Mirror]] object is parametric, it will update if its source object changes.
  
To create copies or clones, and manually place them use [[Draft Move]], [[Draft Rotate]], and [[Draft Clone]].
+
The command can be used on 2D objects created with the [[Draft_Workbench|Draft Workbench]] or [[Sketcher_Workbench|Sketcher Workbench]], but also on many 3D objects such as those created with the [[Part_Workbench|Part Workbench]], [[PartDesign_Workbench|PartDesign Workbench]] or [[Arch_Workbench|Arch Workbench]].
  
 
[[Image:Draft_Mirror_example.jpg|400px]]
 
[[Image:Draft_Mirror_example.jpg|400px]]
{{Caption|Mirrored object created using a mirroring line}}
+
{{Caption|Mirroring an object}}
  
==How to use==
+
==Usage==  
# Select an object that you wish to mirror.
 
# Press the {{Button|[[Image:Draft Mirror.svg|16px]] [[Draft Mirror]]}} button. If no object is selected, you will be invited to select one.
 
# Click a first point on the 3D view, or type a [[Draft_Coordinates|coordinate]] and press the {{Button|[[Image:Draft_AddPoint.svg|16px]] [[Draft_AddPoint|add point]]}} button.
 
# Click a second point on the 3D view, or type a [[Draft_Coordinates|coordinate]] and press the {{Button|[[Image:Draft_AddPoint.svg|16px]] [[Draft_AddPoint|add point]]}} button. These points define a line, which together with the camera view, define a mirroring plane that is used to create the mirrored object.
 
  
After creating the mirrored copy, its binding with the original object can be removed using the {{Button|[[Image:Tree_Part.svg|16px]] [[Part_CreateSimpleCopy|Part Create simple copy]]}} tool.
+
See also: [[Draft_Snap|Draft Snap]] and [[Draft_Constrain|Draft Constrain]].
  
A mirrored copy of a Draft object can be turned into a [[Draft Wire]], by using {{Button|[[Image:Draft Downgrade.svg|16px]] [[Draft Downgrade]]}} then {{Button|[[Image:Draft Upgrade.svg|16px]] [[Draft Upgrade]]}}.
+
# Optionally select one or more objects.
 +
# There are several ways to invoke the command:
 +
#* Press the {{Button|[[Image:Draft_Mirror.svg|16px]] [[Draft_Mirror|Draft Mirror]]}} button.
 +
#* Select the {{MenuCommand|Modification → [[Image:Draft_Mirror.svg|16px]] Mirror}} option from the menu.
 +
#* Use the keyboard shortcut: {{KEY|M}} then {{KEY|I}}.
 +
# If you have not yet selected an object: select an object in the [[3D_view|3D view]].
 +
# The {{MenuCommand|Mirror}} task panel opens. See [[#Options|Options]] for more information.
 +
# Pick the first point of the mirror plane in the [[3D_view|3D view]], or type coordinates and press the {{Button|[[Image:Draft_AddPoint.svg|16px]] Enter point}} button.
 +
# Pick the second point of the mirror plane in the [[3D_view|3D view]], or type coordinates and press the {{Button|[[Image:Draft_AddPoint.svg|16px]] Enter point}} button.
 +
# The mirror plane is defined by the selected points and the normal of the [[Draft_SelectPlane|Draft working plane]].
  
 
==Options==
 
==Options==
* Press {{KEY|X}}, {{KEY|Y}} or {{KEY|Z}} after the first point to constrain the second point on the given axis.
+
 
* To enter coordinates manually, simply enter the numbers, then press {{KEY|Enter}} between each X, Y and Z component.
+
The single character keyboard shortcuts mentioned here can be changed. See [[Draft_Preferences|Draft Preferences]].
* Press {{KEY|R}} or click the checkbox to toggle ''relative'' mode. If relative mode is on, the coordinates of the second point are relative to the first one; if not, they are absolute, taken from the origin (0,0,0).
+
 
* Press {{KEY|T}} or click the checkbox to toggle ''continue'' mode. If continue mode is on, the Mirror tool will restart after you give the second point, allowing you to put another object without pressing the tool button again.
+
* To manually enter coordinates enter the X, Y and Z component, and press {{KEY|Enter}} after each. Or you can press the {{Button|[[Image:Draft_AddPoint.svg|16px]] Enter point}} button when you have the desired values. It is advisable to move the pointer out of the [[3D_view|3D view]] before entering coordinates.
* Hold {{KEY|Ctrl}} while drawing to force [[Draft_Snap|snapping]] your point to the nearest snap location, independently of the distance.
+
* Press {{KEY|R}} or click the {{MenuCommand|Relative}} checkbox to toggle relative mode. If relative mode is on, the coordinates of the second point are relative to the first point, else they are relative to the coordinate system origin.
* Hold {{KEY|Shift}} while drawing to [[Draft_Constrain|constrain]] your second point horizontally or vertically in relation to the first one.
+
* Press {{KEY|G}} or click the {{MenuCommand|Global}} checkbox to toggle global mode. If global mode is on, coordinates are relative to the global coordinate system, else they are relative to the [[Draft_SelectPlane|working plane]] coordinate system. {{Version|0.20}}
* Press {{KEY|Esc}} or the {{Button|Close}} button to abort the current command.
+
* The {{MenuCommand|Continue}} checkbox, displayed in FreeCAD version 0.19 and earlier, has no purpose for this command.
 +
* The {{MenuCommand|Modify subelements}} checkbox, displayed in FreeCAD version 0.19 and earlier, has no purpose for this command.
 +
* Press {{KEY|S}} to switch [[Draft_Snap|Draft snapping]] on or off.
 +
* Press {{KEY|Esc}} or the {{Button|Close}} button to abort the command.
 +
 
 +
==Notes==
 +
 
 +
* Mirrored copies of [[Draft_Line|Draft Lines]], [[Draft_Wire|Draft Wires]], [[Draft_Arc|Draft Arcs]] and [[Draft_Circle|Draft Circles]] can be turned into independent editable Draft objects by using [[Draft_Downgrade|Draft Downgrade]] and then [[Draft_Upgrade|Draft Upgrade]].
 +
* The [[Part_SimpleCopy|Part SimpleCopy]] command can be used to create a copy of a mirrored object that is not linked to its source object.
 +
 
 +
==Preferences==
 +
 
 +
See also: [[Preferences_Editor|Preferences Editor]] and [[Draft_Preferences|Draft Preferences]].
 +
 
 +
* To change the number of decimals used for the input of coordinates: {{MenuCommand|Edit → Preferences... → General → Units → Units settings → Number of decimals}}.
  
 
==Properties==
 
==Properties==
* {{PropertyData|Source}}: specifies the object to mirror,
+
 
* {{PropertyData|Base}}: specifies the base point of the mirror plane.
+
See also: [[property_editor|Property editor]].
* {{PropertyData|Normal}}: specifies the normal direction of the mirror plane.
+
 
 +
A [[Part_Mirror|Part Mirror]] object is derived from a [[Part_Feature|Part Feature]] object and inherits all its properties. It also has the following additional properties:
 +
 
 +
===Data===
 +
 
 +
{{TitleProperty|Base}}
 +
 
 +
* {{PropertyData|Source|Link}}: specifies the object that is mirrored.
 +
 
 +
{{TitleProperty|Plane}}
 +
 
 +
* {{PropertyData|Base|Vector}}: specifies the base point of the mirror plane.
 +
* {{PropertyData|Normal|Vector}}: specifies the normal direction of the mirror plane.
  
 
==Scripting==
 
==Scripting==
{{Emphasis|See also:}} [[Draft API]] and [[FreeCAD Scripting Basics]].
 
  
The Clone tool can be used in [[macros]] and from the [[Python]] console by using the following function:
+
See also: [https://freecad.github.io/SourceDoc/ Autogenerated API documentation] and [[FreeCAD Scripting Basics|FreeCAD Scripting Basics]].
 +
 
 +
To mirror objects use the {{incode|mirror}} method of the Draft module.
 +
 
 
{{Code|code=
 
{{Code|code=
 
mirrored_list = mirror(objlist, p1, p2)
 
mirrored_list = mirror(objlist, p1, p2)
 
}}
 
}}
  
* Creates [[Part Mirror]] objects from {{incode|objlist}}, which can be a single object or a list of objects.
+
* {{incode|objlist}} contains the objects to be mirrored. It is either a single object or a list of objects.
* The mirroring plane is defined by the line built with points {{incode|p1}} and {{incode|p2}}, and parallel to the current view.
+
* {{incode|p1}} is the first point of the mirror plane.
* {{incode|mirrored_list}} is returned with the new objects.
+
* {{incode|p2}} is the second point of the mirror plane.
** {{incode|mirrored_list}} is either a single object or a list of objects, depending on the input {{incode|objlist}}.
+
* If the [[Draft_SelectPlane|Draft working plane]] is available the alignment of the mirror plane is determined by its normal, else the view direction of the camera in the active [[3D_view|3D view]] is used. If the graphical interface is not available the Z axis is used.
 +
* {{incode|mirrored_list}} is returned with the new {{incode|Part::Mirroring}} objects. It is either a single object or a list of objects, depending on {{incode|objlist}}.
  
 
Example:
 
Example:
 +
 
{{Code|code=
 
{{Code|code=
import FeeCAD, Draft
+
import FreeCAD as App
 +
import Draft
  
place = FreeCAD.Placement(FreeCAD.Vector(1000, 0, 0), FreeCAD.Rotation())
+
doc = App.newDocument()
Polygon1 = Draft.makePolygon(3, 750)
 
Polygon2 = Draft.makePolygon(5, 750, placement=place)
 
  
p1 = FreeCAD.Vector(2000, -1000, 0)
+
place = App.Placement(FreeCAD.Vector(1000, 0, 0), App.Rotation())
p2 = FreeCAD.Vector(2000, 1000, 0)
+
polygon1 = Draft.make_polygon(3, 750)
 +
polygon2 = Draft.make_polygon(5, 750, placement=place)
  
Line1 = Draft.makeLine(p1, p2)
+
p1 = App.Vector(2000, -1000, 0)
mirrored1 = Draft.mirror(Polygon1, p1, p2)
+
p2 = App.Vector(2000, 1000, 0)
  
Line2 = Draft.makeLine(-p1, -p2)
+
line1 = Draft.make_line(p1, p2)
mirrored2 = Draft.mirror([Polygon1, Polygon2], -p1, -p2)
+
mirrored1 = Draft.mirror(polygon1, p1, p2)
 +
 
 +
Line2 = Draft.make_line(-p1, -p2)
 +
mirrored2 = Draft.mirror([polygon1, polygon2], -p1, -p2)
 +
 
 +
doc.recompute()
 
}}
 
}}
  
{{Docnav|[[Draft_Drawing|Drawing]]|[[Draft_Stretch|Stretch]]|[[Draft_Module|Draft]]|IconL=Draft_Drawing.svg|IconC=Workbench_Draft.svg|IconR=Draft_Stretch.svg}}
 
  
{{Draft Tools navi}}
+
{{Docnav
 +
|[[Draft_Scale|Scale]]
 +
|[[Draft_Offset|Offset]]
 +
|[[Draft_Workbench|Draft]]
 +
|IconL=Draft_Scale.svg
 +
|IconR=Draft_Offset.svg
 +
|IconC=Workbench_Draft.svg
 +
}}
  
{{Userdocnavi}}
+
{{Draft Tools navi{{#translation:}}}}
{{clear}}
+
{{Userdocnavi{{#translation:}}}}

Latest revision as of 19:37, 24 January 2022

Other languages:
Deutsch • ‎English • ‎Türkçe • ‎español • ‎français • ‎italiano • ‎polski • ‎português do Brasil • ‎română • ‎русский
Arrow-left.svg Previous: Draft Scale.svg Scale
Next: Offset Draft Offset.svg Arrow-right.svg

Draft Mirror.svg Yansıt

Menü konumu
Draft → Mirror
Tezgahlar
Draft, Arch
Varsayılan kısayol
M I
Versiyonda tanıtıldı
-
Ayrıca bkz
Draft Scale

Description

The Draft Mirror.svg Draft Mirror command creates mirrored copies, Part Mirror objects, from selected objects. A Part Mirror object is parametric, it will update if its source object changes.

The command can be used on 2D objects created with the Draft Workbench or Sketcher Workbench, but also on many 3D objects such as those created with the Part Workbench, PartDesign Workbench or Arch Workbench.

Draft Mirror example.jpg

Mirroring an object

Usage

See also: Draft Snap and Draft Constrain.

  1. Optionally select one or more objects.
  2. There are several ways to invoke the command:
    • Press the Draft Mirror.svg Draft Mirror button.
    • Select the Modification → Draft Mirror.svg Mirror option from the menu.
    • Use the keyboard shortcut: M then I.
  3. If you have not yet selected an object: select an object in the 3D view.
  4. The Mirror task panel opens. See Options for more information.
  5. Pick the first point of the mirror plane in the 3D view, or type coordinates and press the Draft AddPoint.svg Enter point button.
  6. Pick the second point of the mirror plane in the 3D view, or type coordinates and press the Draft AddPoint.svg Enter point button.
  7. The mirror plane is defined by the selected points and the normal of the Draft working plane.

Options

The single character keyboard shortcuts mentioned here can be changed. See Draft Preferences.

  • To manually enter coordinates enter the X, Y and Z component, and press Enter after each. Or you can press the Draft AddPoint.svg Enter point button when you have the desired values. It is advisable to move the pointer out of the 3D view before entering coordinates.
  • Press R or click the Relative checkbox to toggle relative mode. If relative mode is on, the coordinates of the second point are relative to the first point, else they are relative to the coordinate system origin.
  • Press G or click the Global checkbox to toggle global mode. If global mode is on, coordinates are relative to the global coordinate system, else they are relative to the working plane coordinate system. introduced in version 0.20
  • The Continue checkbox, displayed in FreeCAD version 0.19 and earlier, has no purpose for this command.
  • The Modify subelements checkbox, displayed in FreeCAD version 0.19 and earlier, has no purpose for this command.
  • Press S to switch Draft snapping on or off.
  • Press Esc or the Close button to abort the command.

Notes

Preferences

See also: Preferences Editor and Draft Preferences.

  • To change the number of decimals used for the input of coordinates: Edit → Preferences... → General → Units → Units settings → Number of decimals.

Properties

See also: Property editor.

A Part Mirror object is derived from a Part Feature object and inherits all its properties. It also has the following additional properties:

Data

Base

  • VeriSource (Link): specifies the object that is mirrored.

Plane

  • VeriBase (Vector): specifies the base point of the mirror plane.
  • VeriNormal (Vector): specifies the normal direction of the mirror plane.

Scripting

See also: Autogenerated API documentation and FreeCAD Scripting Basics.

To mirror objects use the mirror method of the Draft module.

mirrored_list = mirror(objlist, p1, p2)
  • objlist contains the objects to be mirrored. It is either a single object or a list of objects.
  • p1 is the first point of the mirror plane.
  • p2 is the second point of the mirror plane.
  • If the Draft working plane is available the alignment of the mirror plane is determined by its normal, else the view direction of the camera in the active 3D view is used. If the graphical interface is not available the Z axis is used.
  • mirrored_list is returned with the new Part::Mirroring objects. It is either a single object or a list of objects, depending on objlist.

Example:

import FreeCAD as App
import Draft

doc = App.newDocument()

place = App.Placement(FreeCAD.Vector(1000, 0, 0), App.Rotation())
polygon1 = Draft.make_polygon(3, 750)
polygon2 = Draft.make_polygon(5, 750, placement=place)

p1 = App.Vector(2000, -1000, 0)
p2 = App.Vector(2000, 1000, 0)

line1 = Draft.make_line(p1, p2)
mirrored1 = Draft.mirror(polygon1, p1, p2)

Line2 = Draft.make_line(-p1, -p2)
mirrored2 = Draft.mirror([polygon1, polygon2], -p1, -p2)

doc.recompute()


Arrow-left.svg Previous: Draft Scale.svg Scale
Next: Offset Draft Offset.svg Arrow-right.svg